Page MenuHomeFreeBSD

Parallel zfs mounting
ClosedPublic

Authored by jack_gandi.net on Feb 7 2019, 10:12 AM.

Details

Summary

This patch implements parallel mounting for zfs filesystems. This was first implemented on Illumos and ported to ZOL. After asking on the zfs-devel mailing list it was suggested that I start with the ZOL patch because it would be easier to port.

Delphix has seen huge decrease in latency of the mount phase with this patch (see results here: https://github.com/openzfs/openzfs/commit/a3f0e2b569). Performance improvements measured at Gandi are on par with those at Delphix.

Mailing thread here: https://lists.freebsd.org/pipermail/zfs-devel/2019-February/000516.html

Porting Notes:

ZOL-commit: https://github.com/zfsonlinux/zfs/commit/a10d50f999511d304f910852c7825c70c9c9e303

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

jack_gandi.net created this revision.Feb 7 2019, 10:12 AM
jack_gandi.net edited the summary of this revision. (Show Details)Feb 7 2019, 10:28 AM
kib edited reviewers, added: avg; removed: kib.Feb 7 2019, 10:34 AM
kib added a subscriber: kib.

Some updates:

This feature is listed here: https://docs.google.com/spreadsheets/d/1CFapSYxA5QRFYy5k6ge3FutU7zbAWbaeGN2nKVXgxCI/edit#gid=0 as not yet implemented for FreeBSD.
As far as I understand, FreeBSD is planning to rebase on ZoL. If this is the case we will get this feature for free with ZoF, so depending on how soon the rebase will this patch may or may not be useful to merge.

emaste added a subscriber: mmacy.Feb 18 2019, 7:43 PM
avg accepted this revision.Feb 22 2019, 11:56 AM

I haven't thoroughly examined the change, but the procedure you followed sounds good to me.
And if it works, then it is good enough for me.

Also, after this is committed it would make sense to do a "record only" merge from the illumos vendor area for the corresponding illumos commit.

This revision is now accepted and ready to land.Feb 22 2019, 11:56 AM
sef accepted this revision.Feb 23 2019, 7:51 AM
sef added a subscriber: sef.

Seems generally fine to me, although I haven't looked at the ZoL side for comparison.

This revision was automatically updated to reflect the committed changes.